#ifndef _PLUGIN_H
#define _PLUGIN_H
extern char msg[1024];
extern int gmsgSetupMap;
extern int gmsgTextMsg;
extern int gmsgScreenFade;
extern int gmsgShowMenu;

extern int NumLocations;
typedef struct locationinfo_s
{
	char	 Name[256];
	Vector	 Origin[2];

} locationinfo_t;

extern locationinfo_t LocationInfo[128];

typedef struct playerdata_s
{
	int			iNumPhases;
	int			iPhaseGates[16];
	int			iInPhaseMenu;
	float		flPhaseDelay;
	int			iLastPhaseUsed;

} playerdata_t;

extern playerdata_t PlayerData[33];


extern int				Q_strncasecmp (const char *s1, const char *s2, int n);
extern int				Q_strcasecmp (const char *s1, const char *s2);
extern char			   *Q_strcasestr (const char * s1, const char * s2);

extern const char			 *LookupLocationTitle(const char *pszTitle);
extern int					  UTIL_GetPlayerSpecies(edict_t *pEntity);
extern char					 *UTIL_GetLocation(Vector &origin);
extern void					  UTIL_ShowMenu( edict_t *pEdict, int slots, int displaytime, bool needmore, char *aMenuList );
extern int					  UTIL_CountBuildings(const char *building);
extern bool					  UTIL_IsBuilt(edict_t *pent);
extern bool				      UTIL_IsValidEntity( edict_t *pent );

inline unsigned short FixedUnsigned16( float value, float scale )
{
	int output;
	
	output = (int)(value * scale);
	if ( output < 0 )
		output = 0;
	if ( output > 0xFFFF )
		output = 0xFFFF;
	
	return (unsigned short)output;
}

inline short FixedSigned16( float value, float scale )
{
	int output;
	
	output = (int)(value * scale);
	
	if ( output > 32767 )
		output = 32767;
	
	if ( output < -32768 )
		output = -32768;
	
	return (short)output;
}

inline void SAFE_USER_MSG(int &gmsgvar, const char *szMsgName, const int &iSize) {
	if(gmsgvar == 0) 
	{
		//attempt to get the msg from the game that's running
		gmsgvar = GET_USER_MSG_ID( &Plugin_info, szMsgName, NULL);
		
		//and if that fails, register it ourselves
		if(gmsgvar == 0) gmsgvar = REG_USER_MSG(szMsgName, iSize);
	}
}

#endif

