#include "extdll.h"
#include "dllapi.h"
#include "meta_api.h"
#include "plugin.h"
#include "shake.h"
#include "cbase.h"

int gmsgSetupMap = 0;
int gmsgTextMsg = 0;
int gmsgScreenFade = 0;
int gmsgShowMenu = 0;

void UTIL_LogPrintf( char *fmt, ... )
{
   va_list      argptr;
   static char  string[1024];
   
   va_start ( argptr, fmt );
   vsprintf ( string, fmt, argptr );
   va_end   ( argptr );

   // Print to server console
   ALERT( at_logged, "%s", string );
}

CBaseEntity *UTIL_FindEntityByString( CBaseEntity *pStartEntity, const char *szKeyword, const char *szValue )
{
	edict_t	*pentEntity;

	if (pStartEntity)
		pentEntity = pStartEntity->edict();
	else
		pentEntity = NULL;

	pentEntity = FIND_ENTITY_BY_STRING( pentEntity, szKeyword, szValue );

	if (!FNullEnt(pentEntity))
		return CBaseEntity::Instance(pentEntity);
	return NULL;
}

CBaseEntity *UTIL_FindEntityByClassname( CBaseEntity *pStartEntity, const char *szName )
{
	return UTIL_FindEntityByString( pStartEntity, "classname", szName );
}

int Q_strncasecmp (const char *s1, const char *s2, int n)
{
	int		c1, c2;
	
	while (1)
	{
		c1 = *s1++;
		c2 = *s2++;

		if (!n--)
			return 0;		// strings are equal until end point
		
		if (c1 != c2)
		{
			if (c1 >= 'a' && c1 <= 'z')
				c1 -= ('a' - 'A');
			if (c2 >= 'a' && c2 <= 'z')
				c2 -= ('a' - 'A');
			if (c1 != c2)
				return -1;		// strings not equal
		}
		if (!c1)
			return 0;		// strings are equal
	}
	
	return -1;
}

int Q_strcasecmp (const char *s1, const char *s2)
{
	return Q_strncasecmp (s1, s2, 99999);
}

char * Q_strcasestr (const char * s1, const char * s2)
{

	char s1a[512] = "";
	char s2a[512] = "";
	strcpy(s1a, s1);
	strcpy(s2a, s2);
    char * ptr = s1a;

    if (!s1a || !s2a || !*s2a) return ptr;

    while (*ptr) {
	if (toupper(*ptr) == toupper(*s2a)) {
	    char * cur1 = ptr + 1;
	    char * cur2 = s2a + 1;
	    while (*cur1 && *cur2 && toupper(*cur1) == toupper(*cur2)) {
		cur1++;
		cur2++;
	    }
	    if (!*cur2)	return ptr;
	}
	ptr++;
    }
    return NULL;

}

//Yes, this is n00b and icky. Shut up. I suck with file access.
const char *LookupLocationTitle(const char *pszTitle)
{
	int iFoundVar = 0;
	static char szValue[512];

	strcpy(szValue, pszTitle);

	FILE * fp;
	fp = fopen ("ns/titles.txt","r"); 
	
	char line_buffer[1024]; 
	
	if (fp != NULL)    
	{          
		while (fgets (line_buffer, 1024, fp) != NULL)      
		{          
			if ((line_buffer[0] == '\n') || ((line_buffer[0] == '/') && (line_buffer[1] == '/')))  
				continue; 

			line_buffer[strlen(line_buffer)-1] = NULL;

			if(Q_strcasestr(line_buffer, pszTitle) && strstr(line_buffer, "_"))
			{
				iFoundVar = 1;
				continue;
			}
			if(iFoundVar == 1)
			{
				iFoundVar = 2;
				continue;
			}

			if(iFoundVar == 2)
			{
				sprintf(szValue, "%s", line_buffer);
				break;
			}
		}
		fclose (fp);
	}
	return szValue;
}

int UTIL_GetPlayerSpecies(edict_t *pEntity)
{
	if(pEntity->v.team)//Make sure they are on a team.
	{
		char *infobuffer;
		char model[32];
		
		infobuffer = (*g_engfuncs.pfnGetInfoKeyBuffer)(pEntity);
		strcpy(model, (g_engfuncs.pfnInfoKeyValue(infobuffer, "model")));
		
		if(FStrEq(model, "soldier") || FStrEq(model, "heavy") || FStrEq(model, "commander"))
			return 1;
		else
			return 2;
		
	}
	return 0;
}

bool UTIL_VecBetween(const Vector& point, const Vector& bottomLeft, const Vector& topRight)
{	
	if(	point.x <= bottomLeft.x 
		&& point.x >= topRight.x
		
		&& point.y <= bottomLeft.y 
		&& point.y >= topRight.y)
	{
		return true;
	}
	return false;
}

char *UTIL_GetLocation(Vector &origin)
{
	int index = 0;
	
	for(int i = 0;i<=NumLocations;i++)
	{					
		if(UTIL_VecBetween(origin, LocationInfo[i].Origin[0], LocationInfo[i].Origin[1]))
		{
			index = i;
		}
	}

	if(!FStrEq(LocationInfo[index].Name, ""))
		return (LocationInfo[index].Name);
	else
		return "Unknown Location";
}

#define MAX_MENU_CHUNK 176

void UTIL_ShowMenu( edict_t *pEdict, int slots, int displaytime, bool needmore, char *aMenuList )
{
	 if (gmsgShowMenu == 0)
      gmsgShowMenu = REG_USER_MSG( "ShowMenu", -1 );

	char *pMenuList = aMenuList;    
	char chunk[MAX_MENU_CHUNK+1];   
	int char_count = 0;

	while ( pMenuList && *pMenuList ) 
	{
		if ( strlen( pMenuList ) < MAX_MENU_CHUNK )
		{
			strcpy( chunk, pMenuList );
		}
		else 
		{
			strncpy( chunk, pMenuList, MAX_MENU_CHUNK );
			chunk[MAX_MENU_CHUNK] = 0;              // strncpy doesn't always append the null terminator
		}
		char_count += strlen( chunk );
		pMenuList = aMenuList + char_count;

		MESSAGE_BEGIN( MSG_ONE, gmsgShowMenu, NULL, pEdict );
			WRITE_SHORT( slots );
			WRITE_CHAR( displaytime );
			WRITE_BYTE(*pMenuList ? TRUE : FALSE); //Need more menu?
			WRITE_STRING(chunk);
		MESSAGE_END();
	}
}

int UTIL_CountBuildings(const char *building)
{
	int iBuildingCount = 0;
	CBaseEntity *pBuilding = NULL;
	while(pBuilding = UTIL_FindEntityByClassname(pBuilding, building))
	{
		if(UTIL_IsBuilt(pBuilding->edict()))
			iBuildingCount++;
	}
	return iBuildingCount;
}

bool UTIL_IsBuilt(edict_t *pent)
{
	if( ! (pent->v.iuser4 & (1<<2)) )
	{
		return true;
	}
	else if(FStrEq(STRING(pent->v.classname),"team_hive") && pent->v.fuser1 >= 1000)
	{
		pent->v.iuser4 &= ~(1<<2);
		return true;
	}
	return false;

}

bool UTIL_IsValidEntity( edict_t *pent )
{
	if ( !pent )
		return FALSE;
	else if (pent->free)
		return FALSE;
	else if ((pent->v.flags & FL_KILLME))
		return FALSE;

	return TRUE;
}

void UTIL_MakeVectors( const Vector &vecAngles )
{
   MAKE_VECTORS( vecAngles );
}

void EMIT_SOUND_DYN(edict_t *entity, int channel, const char *sample, float volume, float attenuation, int flags, int pitch)
{
	EMIT_SOUND_DYN2(entity, channel, sample, volume, attenuation, flags, pitch);
}